Summary:      cstex for tetex 1.x.x (web2c 7.3) based TeX systems
Name:         tetex-cstex
Version:      1.0.0
Release:      5
URL: 	      http://math.feld.cvut.cz/olsak/cstex
Source0:      ftp://math.feld.cvut.cz/pub/cstex/web2c/csplain.tar.gz
Source1:      ftp://math.feld.cvut.cz/pub/cstex/web2c/cslatex.tar.gz
Source2:      ftp://math.feld.cvut.cz/pub/cstex/web2c/csfonts.tar.gz
Source3:      ftp://math.feld.cvut.cz/pub/cstex/web2c/csfonts-t1.tar.gz
Source4:      ftp://math.feld.cvut.cz/pub/cstex/web2c/cspsfonts.tar.gz
Source5:      ftp://math.feld.cvut.cz/pub/cstex/tetex-rpm/mandrake8/pdfcsadds.tar.gz
License:      GPL
Group:        Publishing
BuildRoot:    %{_tmppath}/%{name}-root
BuildArch: noarch
Prefix:	/
Requires: tetex >= 1.0.0
Requires: tetex < 1.0.7-47
Requires: tetex-latex
Requires: tetex-dvips
Distribution: Mandrake Linux
Packager: Peter Gasparovic <pegas@vlake.army.sk>

%description
CsTeX extent for TeX system based on tetex 1.x.x -- 1.0.7-47 (web2c 7.3). It supports typesetting
in Czech/Slovak language in both Babel and CsLaTeX. Contains CS fonts (Metafont and 
Type1-Olsak) and virtual accented metrics of base Adobe fonts (Times, Helvetica, 
Courrier, ...) - see PSNFSS package. For best functionality, install also csindex please.

 Strucny popis cinnosti rpm:
 1. Instalacia suborov z *.tar cstexu - vid README.tetex-1.0 v CSTeX distribucii.
 2. Instalacia "dalsich" suborov:
     pdftex/csfonts/*.* - kodovacie vektory a fontove mapy pre cstex
 3  Uprava konfiguracnych suborov:
     web2c/texmf.cnf - skontrolovana pritomnost TEXINPUTS.cslatex atd., pridane TEXINPUTS.kpsewhich
     web2c/fmtutil.cnf - vlozene riadky pre cs formaty (podla README...)
     tex/generic/config/language.dat - vybrane vzory delenia pre orig. latex (a Babel)
     dvips//config.cfg - opravena volba -o
     pdftex//pdftex.cfg - pridane mapy pre cs fonty a psnfss fonty
 4. Vytvorenie skriptov pre cs verzie plainu, latexu, pdf..., a cp1250 cs verzie (...w)
 5. Vygenerovanie cs formatov a orig. latex formatu (kvoli zmenenemu language.dat)





%prep
%setup -c -T -a 0
%setup -c -T -D -a 1
%setup -c -T -D -a 2
%setup -c -T -D -a 3
%setup -c -T -D -a 4
%setup -c -T -D -a 5


%build
# nic

%install
fmtpath=`kpsewhich texmf.cnf`
fmtpath=`dirname $fmtpath`
fmtpath=`dirname $fmtpath`
fmtpath=`dirname $fmtpath`
#default value for fmtpath should be /usr/share (Mandrake Linux 8.1, 8.2)
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT$fmtpath
cp -r /usr/src/RPM/BUILD/%{name}-%{version}/texmf  $RPM_BUILD_ROOT$fmtpath/texmf

%preun
# $binpath ... where to uninstall csplain, cslatex, pdfcsplain, pdfcslatex:
binpath=`which tex`
binpath=`dirname $binpath`

# $fmtpath ... where to uninstall csplain.fmt and others, and where to begin search of configuration files:
fmtpath=`kpsewhich texmf.cnf`
fmtpath=`dirname $fmtpath`

for fmtname in csplain cslatex pdfcsplain pdfcslatex; do
rm -f $binpath/$fmtname
rm -f $binpath/"$fmtname"w
rm -f $fmtpath/"$fmtname".fmt
done

%postun
# nic

%pre
# nic

%post
# This script installs new scripts: csplain, cslatex, pdfcsplain and
# pdfcslatex into bin directory (these new scripts use TCX tables).
# Next, install-cstex generates CSTeX formats in texmf/web2c.
# For more details, see README.tetex-1.0 in CSTeX distribution.

# $binpath ... where to install csplain, cslatex, pdfcsplain, pdfcslatex:
binpath=`which tex`
binpath=`dirname $binpath`

# $fmtpath ... where to install csplain.fmt and others, and where to begin search of configuration files:
fmtpath=`kpsewhich texmf.cnf`
fmtpath=`dirname $fmtpath`


# configuring texmf.cnf:
cp -f $fmtpath/texmf.cnf $fmtpath/texmf.cnf.old
tmp=`mktemp -q /tmp/texmf.XXXXXX` || error "mktemp"
#--------------------------
line=`grep "^TEXINPUTS.csplain" $fmtpath/texmf.cnf`
if [ "$line" = "" ]; then
  sed $'/^TEXINPUTS.tex/ a\\\n\
TEXINPUTS.csplain = .;$TEXMF/tex/{csplain,plain,generic,}//\  
  ' $fmtpath/texmf.cnf > $tmp
  cp -f $tmp $fmtpath/texmf.cnf
fi
#--------------------------
line=`grep "^TEXINPUTS.cslatex" $fmtpath/texmf.cnf`
if [ "$line" = "" ]; then
  sed $'/^TEXINPUTS.tex/ a\\\n\
TEXINPUTS.cslatex = .;$TEXMF/tex/{cslatex,csplain,latex,generic,}//\  
  ' $fmtpath/texmf.cnf > $tmp
  cp -f $tmp $fmtpath/texmf.cnf
fi
#--------------------------
line=`grep "^TEXINPUTS.pdfcsplain" $fmtpath/texmf.cnf`
if [ "$line" = "" ]; then
  sed $'/^TEXINPUTS.tex/ a\\\n\
TEXINPUTS.pdfcsplain = .;$TEXMF/{pdftex,tex}/{csplain,plain,generic,}//\  
  ' $fmtpath/texmf.cnf > $tmp
  cp -f $tmp $fmtpath/texmf.cnf
fi
#--------------------------
line=`grep "^TEXINPUTS.pdfcslatex" $fmtpath/texmf.cnf`
if [ "$line" = "" ]; then
  sed $'/^TEXINPUTS.tex/ a\\\n\
TEXINPUTS.pdfcslatex = .;$TEXMF/{pdftex,tex}/{cslatex,csplain,latex,generic,}//\  
  ' $fmtpath/texmf.cnf > $tmp
  cp -f $tmp $fmtpath/texmf.cnf
fi
#--------------------------
line=`grep "^TEXINPUTS.kpsewhich" $fmtpath/texmf.cnf`
if [ "$line" = "" ]; then
  sed $'/^TEXINPUTS.tex / a\\\n\
\\\n\
% for searching of strange files (unknown type e.g.)\\\n\
TEXINPUTS.kpsewhich = .;$TEXMF//\
\\\n\
  ' $fmtpath/texmf.cnf > $tmp
  cp -f $tmp $fmtpath/texmf.cnf
fi
rm -f $tmp
chmod 644 $fmtpath/texmf.cnf


# configuring fmtutil.cnf:
cp -f $fmtpath/fmtutil.cnf $fmtpath/fmtutil.cnf.old
tmp=`mktemp -q /tmp/fmtutil.XXXXXX` || error "mktemp"
sed $'/csplain/ d\n\
/cslatex/ d\n\
/pdfcsplain/ d\n\
/pdfcslatex/ d\n\
/^# language-specific/ a\\\n\
 \\\n\
csplain\t\ttex\t\t-\t\tcsplain.ini\\\n\
cslatex\t\ttex\t\tlanguage.dat\tcslatex.ini\\\n\
pdfcsplain\tpdftex\t\t-\t\tcsplain.ini\\\n\
pdfcslatex\tpdftex\t\tlanguage.dat\tcslatex.ini\\\n\
 \\\n\
' $fmtpath/fmtutil.cnf > $tmp
mv -f $tmp $fmtpath/fmtutil.cnf
chmod 644 $fmtpath/fmtutil.cnf


# configuring language.dat:
cp -f $fmtpath/../tex/generic/config/language.dat $fmtpath/../tex/generic/config/language.dat.old
tmp=`mktemp -q /tmp/language.XXXXXX` || error "mktemp"
sed $'/^%/! s/^/%/\n\
/american.*tex/ s/^%//\n\
/=USenglish/ s/^%//\n\
/=english/ s/^%//\n\
/czech.*tex/ s/^%//\n\
/slovak.*tex/ s/^%//\n\
/nohyphenation.*tex/ s/^%//\
' $fmtpath/../tex/generic/config/language.dat > $tmp
mv -f $tmp $fmtpath/../tex/generic/config/language.dat
chmod 644 $fmtpath/../tex/generic/config/language.dat


# configuring dvips//config.ps:
cp -f $fmtpath/../dvips/config/config.ps $fmtpath/../dvips/config/config.ps.old
tmp=`mktemp -q /tmp/dvips.XXXXXX` || error "mktemp"
sed "s/^o /%o /" $fmtpath/../dvips/config/config.ps > $tmp
mv -f $tmp $fmtpath/../dvips/config/config.ps
chmod 644 $fmtpath/../dvips/config/config.ps


# configuring pdftex//pdftex.cfg:
cp -f $fmtpath/../pdftex/config/pdftex.cfg $fmtpath/../pdftex/config/pdftex.cfg.old
tmp=`mktemp -q /tmp/pdftex.XXXXXX` || error "mktemp"
sed $'/map +raw/ d\n\
/map +csf/ d\n\
/^map pdftex.map/ a\\\n\
map +rawfnts.map\\\n\
map +csfont-e.map\
' $fmtpath/../pdftex/config/pdftex.cfg > $tmp
mv -f $tmp $fmtpath/../pdftex/config/pdftex.cfg
chmod 644 $fmtpath/../pdftex/config/pdftex.cfg

 
# script creating for: csplain, cslatex, pdfcsplain a pdfcslatex:
echo installing scripts:
for fmtname in csplain cslatex pdfcsplain pdfcslatex; do
  echo $binpath/$fmtname
  rm -f $binpath/$fmtname
  echo '#!/bin/sh' > $binpath/$fmtname 
  if [ ! -f $binpath/csplain ]; then
     echo You have no write permissions to $binpath
     exit
  fi
  pre=
  if [ "$fmtname" = "pdfcsplain" -o "$fmtname" = "pdfcslatex" ]; then
    pre=pdf
  fi
  echo "exec ${pre}tex -fmt=$fmtname -translate-file=il2-cs" '${1:+"$@"}' >> $binpath/$fmtname
  chmod a+x $binpath/$fmtname
done
for fmtname in csplain cslatex pdfcsplain pdfcslatex; do
  echo $binpath/"$fmtname"w
  rm -f $binpath/"$fmtname"w
  echo '#!/bin/sh' > $binpath/"$fmtname"w 
  if [ ! -f $binpath/csplainw ]; then
     echo You have no write permissions to $binpath
     exit
  fi
  pre=
  if [ "$fmtname" = "pdfcsplain" -o "$fmtname" = "pdfcslatex" ]; then
    pre=pdf
  fi
  echo "exec ${pre}tex -fmt=$fmtname -translate-file=cp1250cs" '${1:+"$@"}' >> $binpath/"$fmtname"w
  chmod a+x $binpath/"$fmtname"w
done


# generovanie formatu:
mktexlsr
cd $fmtpath
tex    -ini -progname=csplain    -fmt=csplain    csplain.ini
if [ ! -f csplain.fmt ]; then
   echo Impossible to make csplain format, something wrong
   echo Have you csplain.tar, csfonts.tar and cslatex.tar installed in your texmf?
   exit
fi
tex    -ini -progname=cslatex    -fmt=cslatex    cslatex.ini
pdftex -ini -progname=pdfcsplain -fmt=pdfcsplain csplain.ini
pdftex -ini -progname=pdfcslatex -fmt=pdfcslatex cslatex.ini
# originalny latex (ale po zmene vzorov delenia slov v language.dat)
tex    -ini -progname=latex      -fmt=latex      latex.ini
pdftex -ini -progname=pdflatex   -fmt=pdflatex   latex.ini
mktexlsr



%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
/usr/share/texmf/doc
/usr/share/texmf/dvips
#/usr/share/texmf/fonts/source/jknappen
/usr/share/texmf/fonts/source/public
/usr/share/texmf/fonts/tfm
/usr/share/texmf/fonts/type1
/usr/share/texmf/fonts/vf
/usr/share/texmf/fonts/vf-cnv
/usr/share/texmf/pdftex
/usr/share/texmf/tex/cslatex
/usr/share/texmf/tex/csplain
#/usr/share/texmf/tex/enctex
/usr/share/texmf/tex/latex


%changelog
* Sat Dec 14 2002 Peter Gasparovic <pegas@vlake.army.sk>
- added check for tetex version < 1.0.7-47 (newer versions has already basic cs support)
- added preuninstall scripts 

* Thu Oct 2 2002 Peter Gasparovic <pegas@vlake.army.sk>
- Scripts *cs*w corrected (reported by Miroslav Fikar) 

* Thu Jul 11 2002 Peter Gasparovic <pegas@vlake.army.sk>
- automated location of TeX tree at build phase 

* Wed Jul 10 2002 Peter Gasparovic <pegas@vlake.army.sk>
- Installation of configuration files (rpm error  message) replaced by installation scripts
- Corrected using of ${1:+"$@"} in scripts cslatex ...
- added mktexlsr at the end of instalation

* Sun Jul 7 2002 Peter Gasparovic <pegas@vlake.army.sk>
- Initial build.
